extends Node2D


enum state {
	IDLE,
	ATTACKING
}

var current_state
var projectile = preload("res://Scenes/projectile.tscn")
var attack_time = 1
var hp = 3

func _ready() -> void:
	trigger_state(state.IDLE)
	$AnimationPlayer.animation_finished.connect(animation_ended)
	
	$Timer.timeout.connect(func ():
		var p = projectile.instantiate()
		get_parent().add_child(p)
		p.global_position = $Marker2D.global_position
		trigger_state(state.ATTACKING)
		$Timer.start(attack_time)
		)
	$Timer.start(attack_time)


func _process(_delta: float) -> void:
	if Input.is_action_just_pressed("ui_accept"):
		var p = projectile.instantiate()
		get_parent().add_child(p)
		p.global_position = $Marker2D.global_position
		trigger_state(state.ATTACKING)
	
	if hp <= 0:
		queue_free()


func trigger_state(c_state):
	current_state = c_state
	if c_state == state.IDLE:
		$Sprite2D.texture = load("res://Sprites/Royal Crew/Archer/Idle-Sheet.png")
		$Sprite2D.hframes = 4
		$AnimationPlayer.play("idle")
		$AnimationPlayer.speed_scale = 3
	if c_state == state.ATTACKING:
		$Sprite2D.texture = load("res://Sprites/Royal Crew/Archer/Hit-Sheet.png")
		$Sprite2D.hframes = 4
		$AnimationPlayer.play("idle") #both share the same amount of frames
		$AnimationPlayer.speed_scale = 3


func animation_ended(_anim_name):
	if current_state == state.IDLE:
		$AnimationPlayer.play("idle")
	elif current_state == state.ATTACKING:
		trigger_state(state.IDLE)
